//'Copyright 2004 Seapine Software, Inc. All rights reserved.
//
//IMPORTANT:  This Software is supplied to you by Seapine Software, Inc. (Seapine)
//in consideration of your agreement to the following terms, and your use, installation,
//modification or redistribution of this Software constitutes acceptance of these terms.
//If you do not agree with these terms, please do not use, install, modify or redistribute
//this Software.
//
//In consideration of your agreement to abide by the following terms, and subject to these
//terms, Seapine grants you a personal, non-exclusive license, under Seapine copyrights in
//this original Seapine software (the Software), to use, reproduce, modify and redistribute
//the Software, with or without modifications, in source and/or binary forms; provided that
//if you redistribute the Software in its entirety and without modifications, you must retain
//this notice and the following text and disclaimers in all such redistributions of the Software.
//Neither the name, trademarks, service marks or logos of Seapine, Inc. may be used to endorse
//or promote products derived from the Software without specific prior written permission from
//Seapine.  Except as expressly stated in this notice, no other rights or licenses, express or
//implied, are granted by Seapine herein, including but not limited to any patent rights that
//may be infringed by your derivative works or by other works in which the Software may be
////incorporated.
//
//The Software is provided by Seapine on an "AS IS" basis.  SEAPINE MAKES NO WARRANTIES,
//EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF NON-INFRINGEMENT,
//MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE, REGARDING THE SOFTWARE OR ITS USE AND
//OPERATION ALONE OR IN COMBINATION WITH YOUR PRODUCTS. 
//
//IN NO EVENT SHALL SEAPINE BE LIABLE FOR ANY SPECIAL, INDIRECT, INCIDENTAL OR CONSEQUENTIAL
//DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
//LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) ARISING IN ANY WAY OUT OF THE USE,
//REPRODUCTION, MODIFICATION AND/OR DISTRIBUTION OF THE SOFTWARE, HOWEVER CAUSED AND WHETHER
//UNDER THEORY OF CONTRACT, TORT (INCLUDING NEGLIGENCE), STRICT LIABILITY OR OTHERWISE, EVEN
//IF SEAPINE HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//******************************************************************************

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace TTPLicenseUsage
{
	/// <summary>
	/// Summary description for MainDlg.
	/// </summary>
	public class MainDlg : System.Windows.Forms.Form
	{
		public static int Main()
		{
			MainDlg main = new MainDlg();
			main.ShowDialog();

			return (0);
		}

		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.Label labelPassword;
		private System.Windows.Forms.Label labelUsername;
		private System.Windows.Forms.TextBox editPassword;
		private System.Windows.Forms.ComboBox comboDatabase;
		private System.Windows.Forms.Label labelDatabase;
		private System.Windows.Forms.CheckBox checkAutoRefresh;
		private System.Windows.Forms.TextBox editInterval;
		private System.Windows.Forms.CheckBox checkShowNamed;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Button buttonClose;
		private System.Windows.Forms.Button buttonLogin;
		private ttsoapcgi m_cgiEngine;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.TextBox editServer;
		private System.Windows.Forms.TextBox editPort;
		private System.Windows.Forms.Button buttonConnect;
		private System.Windows.Forms.TextBox editUsername;
		private System.Windows.Forms.TextBox editLastRefreshed;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.ListView listLicenses;
		private System.Windows.Forms.ColumnHeader columnHeader1;
		private System.Windows.Forms.ColumnHeader columnHeader2;
		private System.Windows.Forms.ColumnHeader columnHeader3;
		private System.Windows.Forms.ColumnHeader columnHeader4;
		private System.Windows.Forms.GroupBox groupBox2;
		private Timer m_timer;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public MainDlg()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			editUsername.Enabled = false;
			editPassword.Enabled = false;
			buttonLogin.Enabled = false;

			buttonLogin.Enabled = false;

			m_cgiEngine = new ttsoapcgi();

			retrieveServerDefaults();
			populateDatabaseList();
			m_timer = new Timer();
			m_timer.Tick += new EventHandler(TimerEventProcessor);
			m_timer.Stop();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.buttonClose = new System.Windows.Forms.Button();
			this.buttonLogin = new System.Windows.Forms.Button();
			this.labelPassword = new System.Windows.Forms.Label();
			this.labelUsername = new System.Windows.Forms.Label();
			this.editPassword = new System.Windows.Forms.TextBox();
			this.editUsername = new System.Windows.Forms.TextBox();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.labelDatabase = new System.Windows.Forms.Label();
			this.comboDatabase = new System.Windows.Forms.ComboBox();
			this.listLicenses = new System.Windows.Forms.ListView();
			this.columnHeader1 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader2 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader3 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader4 = new System.Windows.Forms.ColumnHeader();
			this.checkAutoRefresh = new System.Windows.Forms.CheckBox();
			this.editInterval = new System.Windows.Forms.TextBox();
			this.checkShowNamed = new System.Windows.Forms.CheckBox();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.editServer = new System.Windows.Forms.TextBox();
			this.label3 = new System.Windows.Forms.Label();
			this.editPort = new System.Windows.Forms.TextBox();
			this.buttonConnect = new System.Windows.Forms.Button();
			this.editLastRefreshed = new System.Windows.Forms.TextBox();
			this.label4 = new System.Windows.Forms.Label();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.groupBox1.SuspendLayout();
			this.groupBox2.SuspendLayout();
			this.SuspendLayout();
			// 
			// buttonClose
			// 
			this.buttonClose.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.buttonClose.Location = new System.Drawing.Point(288, 400);
			this.buttonClose.Name = "buttonClose";
			this.buttonClose.Size = new System.Drawing.Size(80, 25);
			this.buttonClose.TabIndex = 11;
			this.buttonClose.Text = "Close";
			// 
			// buttonLogin
			// 
			this.buttonLogin.Location = new System.Drawing.Point(264, 24);
			this.buttonLogin.Name = "buttonLogin";
			this.buttonLogin.RightToLeft = System.Windows.Forms.RightToLeft.Yes;
			this.buttonLogin.Size = new System.Drawing.Size(80, 25);
			this.buttonLogin.TabIndex = 3;
			this.buttonLogin.Text = "Refresh";
			this.buttonLogin.Click += new System.EventHandler(this.buttonLogin_Click);
			// 
			// labelPassword
			// 
			this.labelPassword.Location = new System.Drawing.Point(8, 56);
			this.labelPassword.Name = "labelPassword";
			this.labelPassword.Size = new System.Drawing.Size(64, 16);
			this.labelPassword.TabIndex = 20;
			this.labelPassword.Text = "Password:";
			// 
			// labelUsername
			// 
			this.labelUsername.Location = new System.Drawing.Point(8, 24);
			this.labelUsername.Name = "labelUsername";
			this.labelUsername.Size = new System.Drawing.Size(64, 16);
			this.labelUsername.TabIndex = 19;
			this.labelUsername.Text = "Username:";
			// 
			// editPassword
			// 
			this.editPassword.Cursor = System.Windows.Forms.Cursors.IBeam;
			this.editPassword.Location = new System.Drawing.Point(72, 56);
			this.editPassword.Name = "editPassword";
			this.editPassword.Size = new System.Drawing.Size(176, 20);
			this.editPassword.TabIndex = 2;
			this.editPassword.Text = "";
			// 
			// editUsername
			// 
			this.editUsername.Cursor = System.Windows.Forms.Cursors.IBeam;
			this.editUsername.Location = new System.Drawing.Point(72, 24);
			this.editUsername.Name = "editUsername";
			this.editUsername.Size = new System.Drawing.Size(176, 20);
			this.editUsername.TabIndex = 1;
			this.editUsername.Text = "";
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.Add(this.labelPassword);
			this.groupBox1.Controls.Add(this.editUsername);
			this.groupBox1.Controls.Add(this.editPassword);
			this.groupBox1.Controls.Add(this.labelUsername);
			this.groupBox1.Controls.Add(this.buttonLogin);
			this.groupBox1.Location = new System.Drawing.Point(16, 128);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(352, 88);
			this.groupBox1.TabIndex = 1;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Login";
			// 
			// labelDatabase
			// 
			this.labelDatabase.Location = new System.Drawing.Point(8, 56);
			this.labelDatabase.Name = "labelDatabase";
			this.labelDatabase.Size = new System.Drawing.Size(64, 16);
			this.labelDatabase.TabIndex = 22;
			this.labelDatabase.Text = "Database:";
			// 
			// comboDatabase
			// 
			this.comboDatabase.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.comboDatabase.Location = new System.Drawing.Point(64, 56);
			this.comboDatabase.MaxDropDownItems = 25;
			this.comboDatabase.Name = "comboDatabase";
			this.comboDatabase.Size = new System.Drawing.Size(168, 21);
			this.comboDatabase.TabIndex = 6;
			this.comboDatabase.SelectedIndexChanged += new System.EventHandler(this.comboDatabase_SelectedIndexChanged);
			// 
			// listLicenses
			// 
			this.listLicenses.BackColor = System.Drawing.SystemColors.Control;
			this.listLicenses.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																						   this.columnHeader1,
																						   this.columnHeader2,
																						   this.columnHeader3,
																						   this.columnHeader4});
			this.listLicenses.Enabled = false;
			this.listLicenses.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable;
			this.listLicenses.Location = new System.Drawing.Point(8, 280);
			this.listLicenses.MultiSelect = false;
			this.listLicenses.Name = "listLicenses";
			this.listLicenses.Size = new System.Drawing.Size(360, 112);
			this.listLicenses.TabIndex = 22;
			this.listLicenses.View = System.Windows.Forms.View.Details;
			// 
			// columnHeader1
			// 
			this.columnHeader1.Text = "Type";
			this.columnHeader1.Width = 170;
			// 
			// columnHeader2
			// 
			this.columnHeader2.Text = "In Use";
			// 
			// columnHeader3
			// 
			this.columnHeader3.Text = "Available";
			this.columnHeader3.Width = 66;
			// 
			// columnHeader4
			// 
			this.columnHeader4.Text = "Total";
			// 
			// checkAutoRefresh
			// 
			this.checkAutoRefresh.Checked = true;
			this.checkAutoRefresh.CheckState = System.Windows.Forms.CheckState.Checked;
			this.checkAutoRefresh.Location = new System.Drawing.Point(16, 248);
			this.checkAutoRefresh.Name = "checkAutoRefresh";
			this.checkAutoRefresh.Size = new System.Drawing.Size(160, 16);
			this.checkAutoRefresh.TabIndex = 9;
			this.checkAutoRefresh.Text = "Enable auto refresh every";
			this.checkAutoRefresh.CheckedChanged += new System.EventHandler(this.checkAutoRefresh_CheckedChanged);
			// 
			// editInterval
			// 
			this.editInterval.Location = new System.Drawing.Point(176, 248);
			this.editInterval.Name = "editInterval";
			this.editInterval.Size = new System.Drawing.Size(40, 20);
			this.editInterval.TabIndex = 10;
			this.editInterval.Text = "30";
			this.editInterval.TextChanged += new System.EventHandler(this.editInterval_TextChanged);
			// 
			// checkShowNamed
			// 
			this.checkShowNamed.Location = new System.Drawing.Point(16, 224);
			this.checkShowNamed.Name = "checkShowNamed";
			this.checkShowNamed.Size = new System.Drawing.Size(168, 16);
			this.checkShowNamed.TabIndex = 8;
			this.checkShowNamed.Text = "Show named license usage";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(224, 248);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(24, 16);
			this.label1.TabIndex = 26;
			this.label1.Text = "min";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(8, 24);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(48, 16);
			this.label2.TabIndex = 23;
			this.label2.Text = "Server:";
			// 
			// editServer
			// 
			this.editServer.Cursor = System.Windows.Forms.Cursors.IBeam;
			this.editServer.Location = new System.Drawing.Point(64, 24);
			this.editServer.Name = "editServer";
			this.editServer.Size = new System.Drawing.Size(168, 20);
			this.editServer.TabIndex = 4;
			this.editServer.Text = "";
			this.editServer.TextChanged += new System.EventHandler(this.editServer_TextChanged);
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(240, 24);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(32, 16);
			this.label3.TabIndex = 25;
			this.label3.Text = "Port:";
			// 
			// editPort
			// 
			this.editPort.Cursor = System.Windows.Forms.Cursors.IBeam;
			this.editPort.Location = new System.Drawing.Point(280, 24);
			this.editPort.Name = "editPort";
			this.editPort.Size = new System.Drawing.Size(64, 20);
			this.editPort.TabIndex = 5;
			this.editPort.Text = "";
			this.editPort.TextChanged += new System.EventHandler(this.editPort_TextChanged);
			// 
			// buttonConnect
			// 
			this.buttonConnect.Location = new System.Drawing.Point(256, 56);
			this.buttonConnect.Name = "buttonConnect";
			this.buttonConnect.Size = new System.Drawing.Size(88, 25);
			this.buttonConnect.TabIndex = 7;
			this.buttonConnect.Text = "Get Databases";
			this.buttonConnect.Click += new System.EventHandler(this.buttonConnect_Click);
			// 
			// editLastRefreshed
			// 
			this.editLastRefreshed.BackColor = System.Drawing.SystemColors.Control;
			this.editLastRefreshed.BorderStyle = System.Windows.Forms.BorderStyle.None;
			this.editLastRefreshed.Location = new System.Drawing.Point(88, 400);
			this.editLastRefreshed.Name = "editLastRefreshed";
			this.editLastRefreshed.Size = new System.Drawing.Size(152, 13);
			this.editLastRefreshed.TabIndex = 28;
			this.editLastRefreshed.Text = "";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(8, 400);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(80, 16);
			this.label4.TabIndex = 23;
			this.label4.Text = "Last refreshed:";
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.Add(this.comboDatabase);
			this.groupBox2.Controls.Add(this.labelDatabase);
			this.groupBox2.Controls.Add(this.editPort);
			this.groupBox2.Controls.Add(this.label3);
			this.groupBox2.Controls.Add(this.editServer);
			this.groupBox2.Controls.Add(this.label2);
			this.groupBox2.Controls.Add(this.buttonConnect);
			this.groupBox2.Location = new System.Drawing.Point(16, 16);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(352, 96);
			this.groupBox2.TabIndex = 29;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "Server Connection";
			// 
			// MainDlg
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(376, 438);
			this.Controls.Add(this.groupBox2);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.checkShowNamed);
			this.Controls.Add(this.editInterval);
			this.Controls.Add(this.checkAutoRefresh);
			this.Controls.Add(this.listLicenses);
			this.Controls.Add(this.groupBox1);
			this.Controls.Add(this.buttonClose);
			this.Controls.Add(this.editLastRefreshed);
			this.Controls.Add(this.label4);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.Name = "MainDlg";
			this.Text = "TestTrack Pro - License Usage";
			this.groupBox1.ResumeLayout(false);
			this.groupBox2.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void retrieveServerDefaults()
		{
			try
			{
				string strServer = "", strPort = "";

				// -meh. Read from saved values!

				if (strServer.Length == 0)	{ strServer = "127.0.0.1"; }
				if (strPort.Length == 0)	{ strPort = "80"; }

				editServer.Text = strServer;
				editPort.Text = strPort;

				m_cgiEngine.Url = buildUrl(strServer + ":" + strPort);
			}
			catch (Exception) {}
		}

		private void populateDatabaseList()
		{
			Cursor = Cursors.WaitCursor;
			try
			{
				comboDatabase.Items.Clear();

				CDatabase[] adb = m_cgiEngine.getDatabaseList();
				if (adb != null && adb.Length > 0)
				{
					for (int i = 0; i < adb.Length; ++i) { comboDatabase.Items.Add( adb[i].name); }
					comboDatabase.SelectedIndex = 0;
				}
			}
			catch (Exception)
			{
				MessageBox.Show( this,
								 "Unable to retrieve databases for the server at " + editServer.Text+":"+editPort.Text + ". \nMake sure the server and port connection parameters are correct. \nNote that the default port for SOAP services is 80.",
								 "Error fetching databases", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
			}

			editUsername.Enabled = comboDatabase.Text.Length > 0;
			editPassword.Enabled = comboDatabase.Text.Length > 0;
			buttonLogin.Enabled = comboDatabase.Text.Length > 0;
			Cursor = Cursors.Default;
		}

		private bool populateLicenseList()
		{
			bool fResult = false;
			Cursor = Cursors.WaitCursor;
			listLicenses.Items.Clear(); // wipe out old data

			long lCookie = -1;
			try
			{
				lCookie = m_cgiEngine.DatabaseLogon( comboDatabase.Text, editUsername.Text, editPassword.Text);

				if (lCookie != -1)
				{
					fResult = true;
					CUserLicense[] alist = m_cgiEngine.getUserLicenseList( lCookie);
					for (int i = 0; alist != null && i < alist.Length; ++i)
					{
						if (alist[i].name == "Named" && !checkShowNamed.Checked) { continue; }

						listLicenses.Items.Add( alist[i].name);
						listLicenses.Items[i].SubItems.Add( alist[i].numberUsed.ToString());
						listLicenses.Items[i].SubItems.Add( (alist[i].numberTotal - alist[i].numberUsed).ToString());
						listLicenses.Items[i].SubItems.Add( alist[i].numberTotal.ToString());
					}

					m_cgiEngine.DatabaseLogoff(lCookie);
				}

				editLastRefreshed.Text = System.DateTime.Now.ToShortDateString() + " " + System.DateTime.Now.ToShortTimeString();
			}
			catch (Exception)
			{
				MessageBox.Show( this, "Unable to login as " + editUsername.Text + ".",
								 "Login failed", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
			}
			Cursor = Cursors.Default;
			return (fResult);
		}

		private void buttonConnect_Click(object sender, System.EventArgs e)
		{
			try
			{
				m_cgiEngine.Url = buildUrl(editServer.Text + ":" + editPort.Text);
			}
			catch (Exception) {}

			populateDatabaseList();
		}

		private void buttonLogin_Click(object sender, System.EventArgs e)
		{
			m_timer.Stop();
			if (populateLicenseList())
			{
				m_timer.Interval = System.Convert.ToInt32(editInterval.Text) * 60 * 1000;
				m_timer.Start();
			}
		}

		private void checkAutoRefresh_CheckedChanged(object sender, System.EventArgs e)
		{
			editInterval.Enabled = checkAutoRefresh.Checked;
			if (checkAutoRefresh.Checked) { m_timer.Stop(); }
		}

		private void editServer_TextChanged(object sender, System.EventArgs e)
		{
			buttonLogin.Enabled = (editServer.Text.Length > 0 && editPort.Text.Length > 0);
		}

		private void editPort_TextChanged(object sender, System.EventArgs e)
		{
			buttonLogin.Enabled = (editServer.Text.Length > 0 && editPort.Text.Length > 0);
		}

		private string buildUrl(string p_strIPPort)
		{
			string str = "http://";
			str += p_strIPPort;
			str += "/scripts/ttsoapcgi.exe";
			return (str);
		}

		private void comboDatabase_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			editUsername.Enabled = comboDatabase.Text.Length > 0;
			editPassword.Enabled = comboDatabase.Text.Length > 0;
			buttonLogin.Enabled = comboDatabase.Text.Length > 0;
		}

		private void editInterval_TextChanged(object sender, System.EventArgs e)
		{
			if (editUsername.Text.Length > 0)
			{
				m_timer.Stop();
				m_timer.Interval = System.Convert.ToInt32(editInterval.Text) * 60 * 1000;
				m_timer.Start();
			}
		}

		private void TimerEventProcessor(Object myObject, EventArgs myEventArgs) 
		{
			m_timer.Stop();
			if (populateLicenseList())
			{
				m_timer.Interval = System.Convert.ToInt32(editInterval.Text) * 60 * 1000;
				m_timer.Start();
			}
		}
	}
}
